unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Menus, Buttons, StylSped;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    ExitMenuItem: TMenuItem;
    MinimiseButton: TStyleSpeed;
    MaximiseButton: TStyleSpeed;
    CloseButton: TStyleSpeed;
    About1: TMenuItem;
    WidowsCornerThing1: TMenuItem;
    N1: TMenuItem;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExitMenuItemClick(Sender: TObject);
    procedure MinimiseButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure GetWndInfo(var f,c:string);
    procedure MaximiseButtonClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  OldRect: TRect;
  ActiveWindow: HWnd;
  MaximiseGlyph: Boolean;
  WindowOnTop: Boolean;

implementation

{$R *.DFM}

procedure TForm1.Timer1Timer(Sender: TObject);
var
  MyRect: TRect;
  WndFilename, Wndclass: string;
  WindowStyleLong: Longint;
  ShiftX,ShiftY: integer;
begin
  ActiveWindow:=GetActiveWindow;

  GetWndInfo(WndFilename, Wndclass);

  if WndFilename=paramstr(0) then exit; {active window is self}

  GetWindowRect(ActiveWindow,MyRect);
  {Get position info for active window}

  if not(
       (MyRect.Left=OldRect.Left) and
       (MyRect.Right=OldRect.Right) and
       (MyRect.Top=OldRect.Top) and
       (MyRect.Bottom=OldRect.Bottom)
     ) then begin {window info has changed}

    WindowStyleLong:=GetWindowLong(ActiveWindow, GWL_STYLE);

    Form1.Visible:=(WindowStyleLong and WS_CAPTION > 0);
    MinimiseButton.Visible:=(WindowStyleLong and WS_MINIMIZEBOX > 0);
    MaximiseButton.Visible:=(WindowStyleLong and WS_MAXIMIZEBOX > 0);

{    WindowOnTop:=

    OnTopButton}

    if MaximiseButton.Visible then MinimiseButton.Left:=0 else MinimiseButton.Left:=16;

    if (WindowStyleLong and WS_THICKFRAME > 0) then ShiftX:=GetSystemMetrics(SM_CXFRAME) {bsSizeable}
    else {if (WindowStyleLong and WS_BORDER > 0) then} ShiftX:=GetSystemMetrics(SM_CXBORDER); {bsSingle or bsDialog}

    ShiftY:=ShiftX;

    if (not MinimiseButton.Visible and not MaximiseButton.Visible and (ShiftX=1)) then begin
      ShiftX:=6; {dialogue box (not a good test but I can't find a better way)}
      ShiftY:=5; {it can leave the buttons in the wrong place}
    end;

    Form1.Left:=MyRect.Right-Form1.Width-ShiftX;
    Form1.Top:=MyRect.Top+ShiftY;
    {move window to top-right}

    {It might be necessary to check for the type of
     window, 'cos dialogues, sizeable and no-border
     windows have different settings}

    if IsZoomed(ActiveWindow) and MaximiseGlyph then begin
      {if it's maximised and showing the maximise glyph}
      MaximiseButton.Glyph.Handle:=LoadBitmap(HInstance,'RESTORE');
      MaximiseGlyph:=False;
    end else if not IsZoomed(ActiveWindow) and not MaximiseGlyph then begin
      {or if it's not maximised and showing the restore glyph}
      MaximiseButton.Glyph.Handle:=LoadBitmap(HInstance,'MAXIMISE');
      MaximiseGlyph:=True;
    end;

    OldRect:=MyRect;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{  Form1.Height:=GetSystemMetrics(SM_CYSIZE); {same size as bitmaps}
  Form1.Height:=18;

  Form1.Width:=50;

  MinimiseButton.Glyph.Handle:=LoadBitmap(HInstance,'MINIMISE');
  CloseButton.Glyph.Handle:=LoadBitmap(HInstance,'CLOSE');
end;

procedure TForm1.ExitMenuItemClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.GetWndInfo(var f,c:string);
begin
  { Fills two strings with the module and class names of a window }
  f[0] := Chr(GetModuleFilename(GetWindowWord(ActiveWindow, GWW_HINSTANCE), @f[1], High(f)-1));
  c[0] := Chr(GetClassName(ActiveWindow, @c[1], High(c)-1));
  {the above was lifted from Calmira}
end;

procedure TForm1.MinimiseButtonClick(Sender: TObject);
begin
  ShowWindow(ActiveWindow,SW_MINIMIZE);
end;

procedure TForm1.CloseButtonClick(Sender: TObject);
begin
  PostMessage(ActiveWindow, WM_CLOSE, 0, 0);
end;

procedure TForm1.MaximiseButtonClick(Sender: TObject);
begin
  if MaximiseGlyph
  then ShowWindow(ActiveWindow,SW_SHOWMAXIMIZED)
  else ShowWindow(ActiveWindow,SW_RESTORE)
end;
{
procedure TForm1.RollUpButtonClick(Sender: TObject);
begin
  if WindowOnTop then
    SetWindowPos(ActiveWindow, HWND_TOP, 0,0,0,0, (SWP_NOMOVE+SWP_NOSIZE+SWP_SHOWWINDOW))
  else begin
    SetWindowPos(ActiveWindow, HWND_TOPMOST, 0,0,0,0, (SWP_NOMOVE+SWP_NOSIZE+SWP_SHOWWINDOW));
  end;
end;
}
procedure TForm1.About1Click(Sender: TObject);
begin
  MessageBox(0,
    'Windows Corner Thing'+#13+#13+
    ' 2000 Maxim Gready'+#13+#13+
    'This program implements Windows 95 style buttons'+#13+
    'on a small window that floats over the active window.'
  ,'Windows Corner Thing',64)
end;

end.
